<template>
	<span>{{value.toLocaleString()}}</span>
</template>


<script>

	export default {
		props: ['number'],
		data: function () {
			return{ 
				value : false,
				target: 0,
				repeat: 0
			}
		},
		created() {
			this.value = this.$props.number;
		},
		methods: {
			updateValue(){
				let increment = Math.ceil((this.target - this.value)/20);
				
				if(this.target > this.value)
					increment = Math.max(1, increment);
				else
					increment = Math.min(-1, increment);
				
				this.value = this.value + increment;
				this.repeat++;
				
				if(this.repeat > 75){
					this.value = this.target;
				}
				
				if(this.value != this.target){
					setTimeout(this.updateValue, 1);
				}
			}
		},
		watch: { 
			number: function(newVal, oldVal) {
				this.target = newVal;
				this.repeat = 0;
				this.updateValue();
			}
		}
	}
</script>


<style>

</style>

